=== debian/changelog ===
gstreamer0.10-ffmpeg (0.10.12-1ubuntu1) oneiric; urgency=low

  * Don't declare dependencies on libavcodec manually. Libavcodec's shlibs
    file is more accurate and less error prone. With libav 0.7, it's
    libavcodec53, not 52.
  
 -- Reinhard Tartler <siretart@tauware.de>  Tue, 09 Aug 2011 16:20:54 +0200

gstreamer0.10-ffmpeg (0.10.12-1) experimental; urgency=low

  * New upstream release, "A year in hell":
    + debian/control:
      - Build-depend on libav >= 0.7, GStreamer >= 0.10.31 and ORC >= 0.4.6.

 -- Sebastian Dröge <slomo@debian.org>  Wed, 20 Jul 2011 13:15:56 +0200

gstreamer0.10-ffmpeg (0.10.11-4) unstable; urgency=low

  * debian/control:
    + Depend on libavcodec52 (<< 5:0) | libavcodec-extra-52 (<< 5:0)
      to allow usage of the ffmpeg-extra packages.

 -- Sebastian Dröge <slomo@debian.org>  Thu, 10 Feb 2011 10:24:42 +0100

gstreamer0.10-ffmpeg (0.10.11-3) unstable; urgency=low

  [ Emilio Pozuelo Monfort ]
  * debian/control,
    debian/rules:
    + Use dpkg-vendor instead of lsb_release.

  [ Sebastian Dröge ]
  * Upload to Unstable.
  * debian/control:
    + Add versioned dependency on libavcodec52 (<< 5:0) to prevent usage
      with the ffmpeg packages of the Debian Multimedia project. Their ffmpeg
      packages break gst-ffmpeg and cause users to file useless bugreports in
      Debian or upstream.

 -- Sebastian Dröge <slomo@debian.org>  Tue, 08 Feb 2011 13:12:54 +0100

gstreamer0.10-ffmpeg (0.10.11-2) experimental; urgency=low

  * debian/control:
    + Add epoch to the orc build dependency to get dependencies
      on the correct version.

 -- Sebastian Dröge <slomo@debian.org>  Fri, 17 Sep 2010 13:29:17 +0200
