=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/gnome.mk
include /usr/share/cdbs/1/rules/utils.mk

CFLAGS += -Wno-error
LDFLAGS += -Wl,-z,defs -Wl,-O1 -Wl,--as-needed

# Let's decide the package name and url depending on the distribution
DISTRO = "$(shell dpkg-vendor --query vendor)"

GST_PACKAGE_NAME := "GStreamer FFMPEG Plugins (unknown Debian derivative)"
GST_PACKAGE_ORIGIN="http://packages.qa.debian.org/gstreamer0.10-ffmpeg"

ifeq ($(DISTRO),"Debian")
GST_PACKAGE_NAME := "GStreamer FFMPEG Plugins (Debian)"
GST_PACKAGE_ORIGIN="http://packages.qa.debian.org/gstreamer0.10-ffmpeg"
endif

ifeq ($(DISTRO),"Ubuntu")
GST_PACKAGE_NAME := "GStreamer FFMPEG Plugins (Ubuntu)"
GST_PACKAGE_ORIGIN="https://launchpad.net/distros/ubuntu/+source/gstreamer0.10-ffmpeg"
endif


DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null)

DEB_CONFIGURE_EXTRA_FLAGS += --with-system-ffmpeg \
                             --with-package-name=$(GST_PACKAGE_NAME) \
                             --with-package-origin=$(GST_PACKAGE_ORIGIN)

DEB_INSTALL_DOCS_ALL += debian/README.Debian NEWS

DEB_DH_STRIP_ARGS := --dbg-package=gstreamer0.10-ffmpeg-dbg

install/gstreamer0.10-ffmpeg::
	rm -f debian/gstreamer0.10-ffmpeg/usr/lib/gstreamer-0.10/libgst*.la
	rm -f debian/gstreamer0.10-ffmpeg/usr/lib/gstreamer-0.10/libgst*.a

common-binary-fixup-arch::
	dh_gstscancodecs
